#include "DEM.h"
#include <errno.h>
#include <stdio.h>
#include <fcntl.h>
#include <math.h>


main(int argc, char *argv[])
{
   DEM *Area;
   DEM_record **Records;

   int  M;
   int  M_Limit;
   int  N;
   int  i;
   int  j;
   unsigned char **Image;
   int    Image_Size;
   char   Image_Header[80];
   char  *Pointer;
   int    Index;
   double Max_Elevation;
   int   *Elevations;

   char   Image_filename[80];
   int    Imagefile;

   if (argc < 1)
   {
      printf("usage: %s <datafile>\n", argv[0]);
   }
   Area = read_DEM_file(argv[1]);
#if 0
   print_DEM(Area);
#endif

   print_DEM_header(Area -> Header);

   N = Area -> Header -> N;
   M = Area -> Header -> M;

   if ((Image = (unsigned char **) malloc(N * sizeof(unsigned char *))) == NULL)
   {
      perror("main()");
      exit(1);
   }

   Image_Size = N * M * sizeof(unsigned char);
   if ((Pointer = (char *) malloc(Image_Size)) == NULL)
   {
      perror("main()");
      exit(1);
   }

   for (i = 0, Index = 0; i < N; i++, Index += M)
      Image[i] = &(Pointer[Index]);

   Max_Elevation = Area -> Header -> Max_Elevation;

   Records = Area -> records;

   for (j = 0; j < N; j++)
   {
      Elevations = (Records[j]) -> Elevations;
      M_Limit = Records[j] -> M;
      for (i = 0; i < M_Limit; i++)
      {
#if 0
         Image[j][i] = (int) floor(( (double) (i * j) / (N * N)) * 255.0 + 0.5);
#endif
         Image[j][i] = (unsigned char) floor(((double) Elevations[i]
                                              / Max_Elevation) * 255.0 + 0.5);
#if 0
         if (Image[i][j] < 66)
            printf("Image[%d][%d] = %d, Elevations[%d] = %d\n",
                   i, j, (int) Image[i][j], i, Elevations[i]);
#endif
      }
      if (M_Limit < M)
         for (i = M_Limit; i < M; i++)
            Image[j][i] = (unsigned char) 0;
   }

   sprintf(Image_filename, "%s.ppm\0", argv[1]);
   if ((Imagefile = open(Image_filename, O_CREAT | O_WRONLY | O_TRUNC,
                         S_IREAD | S_IWRITE)) == -1)
   {
      perror(argv[0]);
      exit(1);
   }

   sprintf(Image_Header, "P5\n%d %d\n255\n\0", M, N);
   write(Imagefile, Image_Header, strlen(Image_Header));

   write(Imagefile, Pointer, Image_Size);
   close(Imagefile);
}
